import java.io.IOException;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class MultiChatSzerver {
	public static void main(String[] args) throws Exception {
		int port = 12345;

		Set<PrintWriter> pws = new HashSet<>();

		try (
			ServerSocket ss = new ServerSocket(port);
		) {
			while (true) {
				Socket s = ss.accept();

				new Thread(() -> {
					try {
						Scanner sc = new Scanner(s.getInputStream());
						PrintWriter pw = new PrintWriter(s.getOutputStream());

						pws.add(pw);

						while (sc.hasNextLine()) {
							String line = sc.nextLine();
							if (line.equals("exit"))   break;

							for (PrintWriter pwOther : pws) {
								pwOther.println(line);
								pwOther.flush();
							}
						}

						pws.remove(pw);

						s.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}).start();

			}
		}
	}
}
