import java.io.PrintWriter;
import java.net.Socket;
import java.util.Scanner;

public class ParhChatKliens {
	public static void main(String[] args) throws Exception {
		int port = 12345;

		try (
			Socket s1 = new Socket("localhost", port);
			Scanner sc1 = new Scanner(s1.getInputStream());
			PrintWriter pw1 = new PrintWriter(s1.getOutputStream());

			Scanner sc2 = new Scanner(System.in);
		) {
			Thread thread1 = new Thread(() -> {
				clientCommunication(new PrintWriter(System.out), sc1);
			});

			Thread thread2 = new Thread(() -> {
				clientCommunication(pw1, sc2);
			});

			thread1.start();
			thread2.start();

			thread1.join();
			thread2.join();
		}
	}

	private static void clientCommunication(PrintWriter pw1, Scanner sc2) {
		while (sc2.hasNextLine()) {
			String line = sc2.nextLine();
			if (line.equals("exit"))   break;
			pw1.println(line);
			pw1.flush();
		}
	}
}
