import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Scanner;

public class ParhChatSzerver {
	public static void main(String[] args) throws Exception {
		int port = 12345;

		try (
			ServerSocket ss = new ServerSocket(port);

			Socket s1 = ss.accept();
			Scanner sc1 = new Scanner(s1.getInputStream());
			PrintWriter pw1 = new PrintWriter(s1.getOutputStream());

			Socket s2 = ss.accept();
			Scanner sc2 = new Scanner(s2.getInputStream());
			PrintWriter pw2 = new PrintWriter(s2.getOutputStream());
		) {
			Thread thread1 = new Thread(() -> {
				sendMessageTo(sc1, pw2);
			});

			Thread thread2 = new Thread(() -> {
				sendMessageTo(sc2, pw1);
			});

			thread1.start();
			thread2.start();

			thread1.join();
			thread2.join();
		}
	}

	private static void sendMessageTo(Scanner sc1, PrintWriter pw2) {
		while (sc1.hasNextLine()) {
			String line = sc1.nextLine();
			if (line.equals("exit"))   break;
			pw2.println(line);
			pw2.flush();
		}
	}
}
